program kniffel;
{ UJA V.0.90, 09.09.94:  1. spielbare Version, nur HSC fehlt! }
{     V.0.99, 10.09.94:  -Version }
{     V.1.00,         :  2-Spieler-Modus }
{     V.1.10          :  mit Tastatursteuerung }
uses crt,graph,intuit,timer,drivers;

const screentitel=
      'U J A s   K n i f f e l                V.1.10   09/94   -   TP6';
      ox=384; oy=128; dx=32; dy=32; dz=12;
      imafil='kniffel.ima';
      hscfile='Kniffel.hsc';
      voll:FillPatternType=($ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff);

type ivector=array[1..13] of integer;
     bvector=array[1..13] of boolean;
     ivec2  =array[1..2] of integer;
     ifeld  =array[1..2] of ivector;
     bfeld  =array[1..2] of bvector;
     hiscore=record namen:string; score:longint end;

var ima                :array[1..12] of Image;
    ima0               :array[0..1]  of Image;
    igad               :array[0..22]  of Gadget;
    itext1,itext2      :array[0..26] of IntuiText;
    ibord,ibord1,ibord2,ibord3,ibord4:Border;
    xy,xy1,xy2             :koords;

    ende,aus,ok,ismulti,geschafft:boolean;
    ch                 :char;
    augen              :ivector;
    f                  :ifeld;
    g                  :bfeld;
    sel,i,mx,my,dran,nplayer:integer;
    punkte             :ivec2;
    hsc                :array[0..11] of hiscore;


{$i initintu.inc }
{$i zeichscr.inc }
{$i aktionen.inc }
{$i knifhsc.inc  }
{ ----------------------------------------------------------------------- }
function checkende(g:bvector):boolean;
var i:integer;
    e:boolean;
begin
   e:=true;
   for i:=1 to 13 do if not g[i] then e:=false;
   checkende:=e;
end;

procedure initgame(var f:ifeld; var g:bfeld; var punkte:ivec2);
var i,j:integer;
begin
   punkte[1]:=0;
   punkte[2]:=0;
   rectfill(168,96,280,380,4);
   for i:=1 to 13 do begin
      for j:=1 to 2 do begin
         f[j,i]:=0;
         g[j,i]:=false;
      end;
      drawgadget(addr(igad[i+5]));
   end;
end;

procedure message(t:string;dran:integer);
var t2:string;
begin
   t2:='---------';
   if dran=1 then t2:='Spieler 1:';
   if dran=2 then t2:='Spieler 2:';
   rectfill(ox,oy-48,ox+223,oy-23,2);
   setcolor(13);
   outtextxy(ox+1,oy-48,t2);
   outtextxy(ox+1,oy-32,t);
   setcolor(3);
   outtextxy(ox,oy-48,t2);
   outtextxy(ox,oy-32,t);
end;

procedure aktionholen(var g:integer);
var ch:char;  var mx,my:integer;
begin
showmouse;
repeat
   g:=0;
   ch:='.';
   delay1(50);
   while keypressed do ch:=readkey;
   if ch<>'.' then begin
      case upcase(ch) of
      #27,'E','Q': g:=20;
      '1'..'6'   : g:=ord(ch)-43;
      'F'        : g:=12;
      'L'        : g:=13;
      'G'        : g:=14;
      'D'        : g:=15;
      'V'        : g:=16;
      'C'        : g:=17;
      'K'        : g:=18;   
      'N'        : g:=19;
      'S'        : g:=21;
      #13,'W'    : g:=22;

      #59        : g:=1;
      #60        : g:=2;
      #61        : g:=3;
      #62        : g:=4;
      #63        : g:=5;
      end;
   end else getgadget(addr(igad[1]),g,mx,my);
until g>0;
hidemouse;
end;






procedure wuerfelwaehlen(var i:integer);
var mx,my:integer;
begin
   message('bitte Wrfel whlen/setzen:',dran);
   i:=0;
   delay(1000);
   while (i>-1) and (i<6) do begin
   {   gadgetup(addr(igad[1]),i,mx,my);   }
      aktionholen(i);
      if (i>0) and (i<6) then begin           { bei vollen Integersets }
         igad[i].onoff:=not igad[i].onoff;    { schmiert er gnadenlos ab! }
         drawgadget(addr(igad[i]));
      end;
   end;
   message('',0);
end;

procedure rangwaehlen(var i:integer);
var mx,my:integer;
begin
   message('bitte setzen:',dran);
   i:=0;
   repeat
     { gadgetup(addr(igad[6]),i,mx,my); }
     aktionholen(i);
   until (i>5) and (i<22);
   message('',0);
end;

procedure sonstigegad;
begin
   ende:=ende or (sel=19) or (sel=21);
   aus:=aus or (sel=20);
   if sel=21 then begin
      igad[sel].onoff:=not igad[sel].onoff;
      drawgadget(addr(igad[sel]));
   end;
end;



begin
   initscreen(ok);
   loadhiscore;
   if ok then begin
      initintuit;
      zeichnescreen;
      showhighscore(376,256,12,12,4,0,2);
      aus:=false;
      for i:=1 to 5 do augen[i]:=i;

      while not aus do begin
         initgame(f,g,punkte);
         refreshgadgets(addr(igad[1]));
         if igad[21].onoff then nplayer:=2 else nplayer:=1;
         rectfill(176,oy-44,255,oy-37,4);
         setcolor(13);
         outtextxy(176,oy-44,' Sp.1');
         if nplayer>1 then outtextxy(216,oy-44,' Sp.2');
         ende:=false;
         geschafft:=false;

         while not (ende or aus) do begin
            for dran:=1 to nplayer do if not (ende or aus) then begin

               { --- max. 4x wrfeln: --- }
               for i:=1 to 5 do igad[i].onoff:=true;
               wuerfeln(augen);
               i:=0;
               sel:=22;
               while (i<3) and ((sel<6) or (sel=22)) do begin
                  inc(i);
                  wuerfelwaehlen(sel);
                  if sel=22 then wuerfeln(augen);
               end;

               { --- setzen: --- }
               if sel=22 then rangwaehlen(sel);
               sonstigegad;
               sel:=sel-5;

               repeat
                  setzen(dran,sel,punkte[dran],ok,ismulti,augen,f[dran],g[dran]);
                  if not ok then begin
                     message('besetzt!',dran);
                     write(chr(7));
                     rangwaehlen(sel);
                     sonstigegad;
                     sel:=sel-5;
                  end;
               until ok or ende or aus;

               if ok then if ismulti then repeat
                  rangwaehlen(sel);
                  sonstigegad;
                  sel:=sel-5;
                  ok:=false;
                  if sel<13 then setzen(dran,sel,punkte[dran],ok,ismulti,augen,f[dran],g[dran]);
               until ok or ende or aus;

            { --- Endcheck und High Score: --- }
               geschafft:=checkende(g[1]);
               if nplayer=2 then
               geschafft:=geschafft and checkende(g[2]);
               ende:=ende or geschafft;

            end;  { Player-Loop }
         end;  { while }

         if geschafft then begin
            for i:=1 to nplayer do
            if punkte[i]>hsc[10].score then begin
               message('Gratuliere!',i);
               updathiscore(punkte[i],376,256,12,12,4,0,2);
               message('',0);
            end;
            gadgetup(addr(igad[19]),sel,mx,my);
            sonstigegad;
         end;

      end;  { Auenschleife }

      closegraph;
   end;
end.
